package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrAdministrativePenalty;
import com.zksy.data.domain.response.XcrAdministrativePenaltyResponse;
import com.zksy.data.mapper.XcrAdministrativePenaltyMapper;
import com.zksy.data.service.XcrAdministrativePenaltyService;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_administrative_penalty(行政处罚信息表)】的数据库操作Service实现
* @createDate 2024-10-13 17:14:26
*/
@Service
@Slf4j
public class XcrAdministrativePenaltyServiceImpl extends ServiceImpl<XcrAdministrativePenaltyMapper, XcrAdministrativePenalty>
    implements XcrAdministrativePenaltyService{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Override
    @Transactional(rollbackFor = Exception.class)
    @XhDataLogRecord("同步行政处罚信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrAdministrativePenalty> toDatabaseList = new Vector<>();
        creditCodes.parallelStream().forEach(creditCode -> {
            HashMap<String, String> requestbodyMap = new HashMap<>();
            requestbodyMap.put("entityCode", creditCode);
            requestbodyMap.put("size", String.valueOf(10));
            requestbodyMap.put("page", String.valueOf(1));
            try {
                List<XcrAdministrativePenalty> list = xhRequestUtil.requestXinyonghuanhuai(requestbodyMap,address,
                        XcrAdministrativePenaltyResponse.class,
                        XcrAdministrativePenalty.class);
                if(list != null){
                    toDatabaseList.addAll(list);
                }
            } catch (Exception e) {
                List<XcrAdministrativePenalty> list = xhRequestUtil.requestXinyonghuanhuai(requestbodyMap,address,
                        XcrAdministrativePenaltyResponse.class,
                        XcrAdministrativePenalty.class);
                if(list != null){
                    toDatabaseList.addAll(list);
                }
            }
        });
        this.remove(null);
        this.saveBatch(toDatabaseList);
        log.info("行政处罚信息同步完成");
    }
}




